public class TestEquationDegre2 {

	private static void resolveEquation(double a, double b, double c, boolean bad) {
		try {
			EquationDegre2 equation;
			System.out.println("---------------------------------------------------------");
			System.out.println("--> Résolution de " + a + "X^2 + " + b + "X + " + c + " = 0 ");
			equation = new EquationDegre2(a, b, c);

			// si mauvais code (paramètre bad à true), on ne résoud pas
			// l'équation avant d'accéder aux solutions
			if (!bad) { equation.resolve(); }

			System.out.println(equation.getNombreRacines() + " racines");

			// il faudrait normalement tenir compte du nombre de racines,
			// tentons quand même ;-)
			System.out.println("x1 = " + equation.getX1());
			System.out.println("x2 = " + equation.getX2());

		} catch (DegeneratedEquationDegre2Exception e) {
			System.err.println("Pas de creation possible de l'équation. Le coefficient de 2nd degré doit être non nul.");
			e.printStackTrace();
		} catch (UnresolvedException e) {
			System.err.println("Opération interdite, l'équation n'est pas résolue.");
			e.printStackTrace();
		} catch (InvalidRootException e) {
			System.err.println("Accès à une racine non autorisé : " + e.getMessage());
			e.printStackTrace();
		}
	}

	public static void main(String[] args){
		// cas 1 : mauvaise construction d'une équation
		resolveEquation(0.0, 1.0, 2.0, false);

		// cas 2 : accès aux infos sans résolution
		resolveEquation(3.0, 4.0, 2.0, true);

		// cas 3 : accès aux racines inexistantes : delta < 0 puis nul
		resolveEquation(3.0, 4.0, 2.0, false);
		resolveEquation(1.0, 4.0, 4.0, false);

		// cas 4 : equation à 2 solutions
		resolveEquation(3.0, 8.0, 2.0, false);
	}
}
